<template>
  <div class="login">
    <h1>Log in</h1>
    <p>
      SSO is yet to be implemented. For now, you can
      <router-link to="/register"
        >register with your email address and password</router-link
      >. If you already have an account, enter your credentials or API token
      below to log in.
    </p>

    <p v-show="error" style="color: red">
      Something went wrong, please double-check your input or try it later
      again. Error message: {{ error }}
    </p>

    <h2>Log in with E-Mail and password</h2>
    <b-form @submit="login">
      <b-row>
        <b-col md="6">
          <b-form-input
            type="email"
            v-model="loginEmail"
            :state="validLoginEmailFormat"
            placeholder="Enter your E-Mail address"
            trim
          />
        </b-col>
        <b-col md="6">
          <b-form-input
            type="password"
            v-model="loginPassword"
            :state="validLoginPasswordFormat"
            placeholder="Enter your Password"
            trim
          />
        </b-col>
      </b-row>
      <b-row v-show="false">
        <b-col>
          <b-form-input
            type="password"
            v-model="honeypot"
            :state="validLoginPasswordFormat"
            placeholder="Confirm your Password"
            trim
          />
        </b-col>
      </b-row>
      <b-button
        type="submit"
        variant="primary"
        :active="validLoginEmailFormat && validLoginPasswordFormat"
        :disabled="!validLoginPasswordFormat || !validLoginPasswordFormat"
      >
        Log in
      </b-button>
      <b-button
        style="margin-left: 1em"
        variant="danger"
        @click="forgotPassword"
        :active="validLoginEmailFormat"
        :disabled="!validLoginEmailFormat"
      >
        Forgot password
      </b-button>
    </b-form>

    <h2>Log in with API token</h2>
    <b-form @submit="setApiToken">
      <label for="token-input">API token:</label>
      <b-row>
        <b-col md="12">
          <b-form-input
            id="token-input"
            v-model="token"
            :state="validTokenFormat"
            placeholder="Enter your OPEN-CUTS api token"
            trim
          />
        </b-col>
      </b-row>
      <b-button
        type="submit"
        variant="primary"
        :active="validTokenFormat"
        :disabled="!validTokenFormat"
      >
        Set API token
      </b-button>
    </b-form>
  </div>
</template>

<script>
import gql from "graphql-tag";

export default {
  computed: {
    validTokenFormat() {
      return !isNaN(parseInt(this.token, 16));
    },
    validLoginPasswordFormat() {
      return this.loginPassword.length >= 10;
    },
    validLoginEmailFormat() {
      return /\S+@\S+\.\S+/.test(this.loginEmail);
    }
  },
  data() {
    return {
      error: null,
      token: "",
      loginPassword: "",
      loginEmail: "",
      honeypot: ""
    };
  },
  methods: {
    getToken() {
      return localStorage.getItem("OC_AUTH_TOKEN") || null;
    },
    setApiToken(evt) {
      evt.preventDefault();
      localStorage.setItem("OC_AUTH_TOKEN", this.token);
      // Do not use router to force re-rendering the login and account nav elements
      window.location.href = "/account";
    },
    login(evt) {
      evt.preventDefault();
      if (this.honeypot) window.location.href = "/";
      this.$apollo
        .query({
          query: gql`
            query($email: String!, $password: String!) {
              login(email: $email, password: $password)
            }
          `,
          variables: {
            email: this.loginEmail,
            password: this.loginPassword
          }
        })
        .then(data => {
          localStorage.setItem("OC_AUTH_TOKEN", data.data.login);
          // Do not use router to force re-rendering the login and account nav elements
          window.location.href = "/account";
        })
        .catch(error => {
          this.error = error;
        });
    },
    forgotPassword() {
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($email: String!) {
              forgotPassword(email: $email) {
                id
              }
            }
          `,
          variables: {
            email: this.loginEmail
          }
        })
        .then(() => {
          // Do not use router to force re-rendering the login and account nav elements
          window.location.href = "/account";
        })
        .catch(error => {
          this.error = error;
        });
    }
  },
  created() {
    if (this.getToken()) {
      // Do not use router to force re-rendering the login and account nav elements
      window.location.href = "/account";
    }
  }
};
</script>
